<?php
/*
Plugin Name: Related Posts RPC
Plugin URI: http://www.notreleasedyet.com
Description: Adds an xmlrpc hook to return an array of related posts based on word or phrase input
Version: 0.1
Author: Brett Terpstra, based heavily on work by Alexander Malov & Mike Lu
*/

// Begin setup

global $ran_plugin;
if (! isset($ran_plugin)) {
      	$ran_plugin = true;
		if (isset($_REQUEST['setup'])) // Setup is initiated using related-posts-rpc.php?setup
		{
        global $file_path, $user_level;
        require_once(dirname(__FILE__).'/../../' .'wp-config.php');
        get_currentuserinfo();
        if ($user_level < 8)
        	die ("Sorry, you must be at least a level 8 user."); // Make sure that user has sufficient priveleges

// SQL query to setup the actual full-text index

		require(dirname(__FILE__).'/../../' .'wp-config.php');

		global $table_prefix;
		
		$connexion = mysql_connect(DB_HOST,DB_USER,DB_PASSWORD) or die("Can't connect.<br />".mysql_error());
		$dbconnexion = mysql_select_db(DB_NAME, $connexion);
		
		if (!$dbconnexion)
		{
			echo mysql_error();
			die();
			}
		$sql_run = 'ALTER TABLE `'.$table_prefix.'posts` ADD FULLTEXT `post_related` ( `post_name` ,'
        . ' `post_content` )';
		$sql_result = mysql_query($sql_run);
		
		if ($sql_result)
			echo ("Congratulations! Full text index was created successfully!");
		
		else
			echo (" Something went wrong. Please check the instructions on how to setup the full text index manually.");
			}
}

// End setup

function escape(&$array) {
	global $wpdb;

	foreach ($array as $k => $v) {
		if (is_array($v)) {
			$this->escape($array[$k]);
		} else if (is_object($v)) {
			//skip
		} else {
			$array[$k] = $wpdb->escape($v);
		}
	}
}

// Begin Related Posts XMLRPC

function wprpc_getRelatedPosts($args) {  
global $wpdb;
	
	  escape($args);

	  $blog_ID     = $args[0];
	  $user_login  = $args[1];
	  $user_pass   = $args[2];
	  $terms   = $args[3];
	
	if (!user_pass_ok($user_login, $user_pass)) {
	    return;
	  }

	
  	$limit = get_option('rpclimit');
 	$show_pass_post = get_option('rpcshow_pass_post');

	$time_difference = get_settings('gmt_offset');
	$now = gmdate("Y-m-d H:i:s",(time()+($time_difference*3600)));
	
	// Primary SQL query
	
    $sql = "SELECT ID, post_title, post_content,"
         . "MATCH (post_name, post_content) "
         . "AGAINST ('$terms') AS score "
         . "FROM $wpdb->posts WHERE "
         . "MATCH (post_name, post_content) "
         . "AGAINST ('$terms') "
		 . "AND post_date <= '$now' "
         . "AND (post_status IN ( 'publish',  'static' )) ";
    if ($show_pass_post=='false') { $sql .= "AND post_password ='' "; }
    $sql .= "ORDER BY score DESC LIMIT $limit";
    $results = $wpdb->get_results($sql);
    if ($results) {
		foreach ($results as $result) {
			$title = stripslashes($result->post_title);
			$permalink = get_permalink($result->ID);
			$struct[] = array(
		      'title' => $title,
		      'permaLink' => $permalink,
		    );
        	
		}
		$related_posts = array();
		  for ($j=0; $j<count($struct); $j++) {
		    array_push($related_posts, $struct[$j]);
		  }
		return $related_posts;
	} else {
        // $error = new IXR_Error(500, 'Either there are no posts, or something went wrong.');
	    return;
    }
}

// End Related Posts XMLRPC

// Begin Related Posts Options

function rpcrp_subpanel() {
     if (isset($_POST['update_rpcrp'])) {
       $option_limit = $_POST['limit'];
       $option_show_pass_post = $_POST['show_pass_post'];
       update_option('rpclimit', $option_limit);
       update_option('rpcshow_pass_post', $option_show_pass_post);
       ?> <div class="updated"><p>Options saved!</p></div> <?php
     }
	?>

	<div class="wrap">
		<h2>XMLRPC Related Posts Options</h2>
		<form method="post">
		<fieldset class="options">
		<table>
			<tr>
				<td><label for="limit">How many related posts would you like to show?</label>:</td>
				<td><input name="limit" type="text" id="limit" value="<?php echo get_option('rpclimit'); ?>" size="2" /></td>
			</tr>
			<tr>
				<td><label for="show_pass_post">Show password protected posts?</label></td>
				<td>
            	<select name="show_pass_post" id="show_pass_post">
              	<option <?php if(get_option('show_pass_post') == 'false') { echo 'selected'; } ?> value="false">False</option>
              	<option <?php if(get_option('show_pass_post') == 'true') { echo 'selected'; } ?> value="true">True</option>
            	</select> 
				</td>
			</tr>
		</table>
		</fieldset>

		<p><div class="submit"><input type="submit" name="update_rpcrp" value="<?php _e('Save!', 'update_rpcrp') ?>"  style="font-weight:bold;" /></div></p>
        
		</form>       
		
    </div>
    
    <div class="wrap">   
        <h2>SQL Index Table Setup</h2>
		<p>This plugin uses the index table installed by the <a href="http://www.w-a-s-a-b-i.com/archives/2006/02/02/wordpress-related-entries-20/" title="WASABI  &raquo; Blog Archive   &raquo; WordPress Related Entries 2.0" >Related Posts</a> plugin.  If this is your first time installing this plugin and you have never installed Related Posts, you will have to run <a href="../wp-content/plugins/related-posts-rpc.php?setup" onclick="window.open(this.href, 'popupwindow', 'width=400,height=150,scrollbars,resizable'); return false;">this script</a> (opens a new window) in order to create the index table required by the plugin. If this fails, please refer to the readme on how to create it manually.</p>
		
    </div>

<?php } 

// End Related Posts Options

function rpcrp_admin_menu() {
   if (function_exists('add_submenu_page')) {
        add_submenu_page('plugins.php', __('XMLRPC Related Posts Options'), __('XMLRPC Rel. Posts Options'), 1, __FILE__, 'rpcrp_subpanel');
        }
}

add_action('admin_menu', 'rpcrp_admin_menu');

add_filter('xmlrpc_methods', 'attach_new_xmlrpc');
function attach_new_xmlrpc($methods) {
	$methods['wordpress.getRelatedPosts'] = 'wprpc_getRelatedPosts';
	return $methods;
}

?>